'****************************************************************************'
'*	Copylight(C) 2011 Kanazawa-soft-design,LLC.All Rights Reserved.
'****************************************************************************'
'*
'*	@file	WaveFile.vb
'*
'*	@brief	WAVEt@C̓ǂݍ.
'*
'*	@author	V 閾
'*

' WAVEt@Cwb_\.
Public Structure	WAVFILEHEADER
	Public RiffId			As String		' RIFFt@Cʎq (RIFF).
	Public FileSize			As Integer		' t@CTCY - 8.
	Public FileType			As String		' t@C^Cv ("WAVE").
	Public FormatId			As String		' tH[}bgʎq ("fmt ").
	Public FormatSize		As Integer		' tH[}bgETCY - 8.
	Public FormatType		As Integer		' tH[}bg^Cv.
	Public Channels			As Integer		' `l.
	Public SamplesPerSec	As Integer		' TvO.
	Public AvgBytesPerSec	As Integer		' 1b̃oCg.
	Public BlockAlign		As Integer		' 1`l̃oCg.
	Public BitsPerSample	As Integer		' 1f[^̃rbg.
End Structure


Public Class CWavFile

	Private m_Fs		As System.IO.FileStream	' WAVt@CEIuWFNg.
	Private m_Header	As WAVFILEHEADER		' WAVt@Cwb_.

	'****************************************************************************'
	'*
	'*	@brief	t@Cǂݍ݃[hŃI[v.
	'*
	'*	@param	[in]	file_name	t@C̃|C^.
	'*
	'*	@retval	TRUE = OK. / FALSE = NG.
	'*
	Public Function	Open( file_name As String ) As Boolean

On Error Goto error_exit:

		' Ƀt@CEI[v̏ꍇAG[ɂ.
		If ( IsNothing( m_Fs ) = False ) Then
			Return False
		End If

		' sȏꍇAG[ɂ.
		If ( file_name = "" ) Then
			Return False
		End If

		' t@Cǂݍ݃[hŃI[v.
		m_Fs = New System.IO.FileStream( file_name, System.IO.FileMode.Open, System.IO.FileAccess.Read )

		'========================================'
		' t@Cwb_͂.
		'========================================'

		' t@C̐擪Xg[ǂݍ.
		Dim buf As Byte()  = New Byte( 256 ) {}
		Dim len As Integer = Read( buf )
		If ( len = 0 ) Then 
			GoTo error_exit
		End If

		' t@Cwb_o.
		Call LoadHeader( buf )

		' RIFFwb_𒲂ׂ.
		If (( m_Header.RiffId   <> "RIFF" ) _
		 Or ( m_Header.FileType <> "WAVE" ) _
		 Or ( m_Header.FileSize <= 32     )) Then
			GoTo error_exit
		End If

		' tH[}bgwb_𒲂ׂ.
		If (( m_Header.FormatId       <> "fmt " ) _
		 Or ( m_Header.Channels       =  0      ) _
		 Or ( m_Header.SamplesPerSec  =  0      ) _
		 Or ( m_Header.AvgBytesPerSec =  0      ) _
		 Or ( m_Header.BlockAlign     =  0      ) _
		 Or ( m_Header.BitsPerSample  =  0      ) _
		 Or ( m_Header.FormatSize     <  16     )) Then
			GoTo error_exit
		End If

		Dim offset As Long
		offset = m_Header.FormatSize + 20

		' f[^wb_o.
		Dim fcc  As String
		Dim size As Long
		fcc  = GetFCC( buf, offset )
		size = GetDWORD( buf, offset + 4 )

		' f[^wb_𒲂ׂ.
		If ( fcc <> "data" Or size = 0 ) Then
			GoTo error_exit
		End If

		' t@Cǂݍ񂾃f[^ȂꍇAG[ɂ.
		If ( m_Fs.Length <= offset ) Then
			GoTo error_exit
		End If

		' t@C̓ǂݍ݈ʒu擪t[ɍ킹Ă.
		m_Fs.Seek( offset + 8, System.IO.SeekOrigin.Begin )

		Return True

error_exit:
		' G[ꍇAt@CN[Y.
		Call Close()

		buf = Nothing

		Return False

	End Function

	'****************************************************************************'
	'*
	'*	@brief	t@CEN[Y.
	'*
	'*	@param	Ȃ.
	'*
	'*	@retval	Ȃ.
	'*
	Public Sub	Close()

		' t@CI[v̏ꍇAN[Y.
		If ( IsNothing( m_Fs ) = False ) Then
			m_Fs.Close()
			m_Fs = Nothing
		End If

	End Sub

	'****************************************************************************'
	'*
	'*	@brief	t@CWAVEf[^ǂݍ.
	'*
	'*	@param	[in]	data	WAVEf[^i[oCgf[^̔z.
	'*
	'*	@retval	t@Cǂݍ񂾃oCg.
	'*
	Public Function Read( ByRef data As Byte() ) As Integer

		Dim len As Integer = 0

On Error Goto error_exit:

		' t@Cf[^ǂݍ.
		If ( IsNothing( m_Fs ) = False ) Then
			len = m_Fs.Read( data, 0, data.Length )
		End If

		Return len

error_exit:
		' G[ꍇAt@CN[Y.
		Call Close()

	End Function

	'****************************************************************************'
	'*
	'*	@brief	WAVt@CI[vǂ𒲂ׂ.
	'*
	'*	@param	Ȃ.
	'*
	'*	@retval	TRUE = t@CEI[v / FALSE = t@CEI[vĂȂ.
	'*
	Public Function IsOpen() As Boolean

		If ( IsNothing( m_Fs ) = True ) Then
			Return False
		Else
			Return True
		End If

	End Function

	'****************************************************************************'
	'*
	'*	@brief	WAVt@C̃tH[}bg`擾.
	'*
	'*	@param	[out]	wf	WAVtH[}bg\.
	'*
	'*	@retval	Ȃ.
	'*
	Public Sub GetWaveInfo( ByRef wf As WaveFormat )

		wf.AverageBytesPerSecond = m_Header.AvgBytesPerSec
		wf.SamplesPerSecond      = m_Header.SamplesPerSec
		wf.BitsPerSample         = m_Header.BitsPerSample
		wf.BlockAlign            = m_Header.BlockAlign
		wf.Channels              = m_Header.Channels
		wf.FormatTag             = WaveFormatTag.Pcm

	End Sub

	'****************************************************************************'
	'*
	'*	@brief	ǂݍ񂾃f[^WAVEt@C̃wb_o.
	'*
	'*	@param	[in]	data	WAVEf[^i[oCgf[^̔z.
	'*
	'*	@retval	t@Cǂݍ񂾃oCg.
	'*
	Private Sub LoadHeader( ByRef data As Byte() )

		' RIFFt@Cʎqo.
		m_Header.RiffId = GetFCC(data, 0 )

		' t@CTCYo.
		m_Header.FileSize = GetDWORD( data, 4 )

		' t@C^Cvo.
		m_Header.FileType = GetFCC(data, 8 )

		' tH[}bgʎqo.
		m_Header.FormatId = GetFCC(data, 12 )

		' tH[}bgTCYo.
		m_Header.FormatSize = GetDWORD( data, 16 )

		' tH[}bg^Cvo.
		m_Header.FormatType = GetWORD( data, 20 )

		' `lo.
		m_Header.Channels = GetWORD( data, 22 )

		' TvOo.
		m_Header.SamplesPerSec = GetDWORD( data, 24 )

		' 1b̃oCgo.
		m_Header.AvgBytesPerSec = GetDWORD( data, 28 )

		' 1`l̃oCgo.
		m_Header.BlockAlign = GetWORD( data, 32 )

		' 1f[^̃rbgo.
		m_Header.BitsPerSample = GetWORD( data, 34 )

	End Sub

	'****************************************************************************'
	'*
	'*	@brief	ǂݍ񂾃f[^16rbgo.
	'*
	'*	@param	[in]	data	Xg[f[^i[oCgf[^̔z.
	'*	@param	[in]	index	of[^̎Qƈʒu.
	'*
	'*	@retval	Xg[o4oCg̐l.
	'*
	Private Function GetWORD( ByRef data As Byte(), ByVal index As Integer ) As Integer

		Dim val As Integer

		val = data( index + 1 )
		val = (val * 256) + data( index )
		Return val

	End Function

	'****************************************************************************'
	'*
	'*	@brief	ǂݍ񂾃f[^32rbgo.
	'*
	'*	@param	[in]	data	Xg[f[^i[oCgf[^̔z.
	'*	@param	[in]	index	of[^̎Qƈʒu.
	'*
	'*	@retval	Xg[o4oCg̐l.
	'*
	Private Function GetDWORD( ByRef data As Byte(), ByVal index As Integer ) As Integer

		Dim val As Integer

		val = data( index + 3 )
		val = (val * 256) + data( index + 2 )
		val = (val * 256) + data( index + 1 )
		val = (val * 256) + data( index )
		Return val

	End Function

	'****************************************************************************'
	'*
	'*	@brief	ǂݍ񂾃f[^4-CODEo.
	'*
	'*	@param	[in]	data	Xg[f[^i[oCgf[^̔z.
	'*	@param	[in]	index	of[^̎Qƈʒu.
	'*
	'*	@retval	Xg[o4-CODE̕.
	'*
	Private Function GetFCC( ByRef data As Byte(), ByVal index As Integer ) As String

		Dim str As String = ""

		For i As Integer = 0 To 3
			str = str + Microsoft.VisualBasic.ChrW( data( index + i ) )
		Next i

		Return str

	End Function

End Class
